if ( SERVER ) then

	AddCSLuaFile( "shared.lua" )
	
	SWEP.HoldType			= "melee"
	
	FrozenYay=false
	
	local BlockedBinds = 
{ 
    "+attack", 
    "+attack2" 
}
 

 


if ( CLIENT ) then

	SWEP.PrintName			= "Handcuffs"
	SWEP.Author			= "Capsup"
	SWEP.Slot			= 1
	SWEP.SlotPos			= 7
	SWEP.DrawAmmo = false;
	SWEP.DrawCrosshair = false;
	SWEP.DrawDotCrosshair = true;
	
	function GM:PlayerBindPress( ply, bind, pressed )
		if ply:GetNWBool("FrozenYay" == true) then 
			for k,v in pairs(BlockedBinds) do 
				if string.find(Bind,v) then 
					return false end
				end 
			end 
		end 
	end
end



------------General Swep Info---------------
SWEP.Author   	    = "Capsup"
SWEP.Contact        = "Capsup@live.dk"
SWEP.PrintName			= "Handcuffs"
SWEP.Purpose        = "Handcuff the mingebags!"
SWEP.Instructions   = "Left click handcuffs people. Right click removes."
SWEP.Spawnable      = true
SWEP.AdminSpawnable  = true
-----------------------------------------------

------------Models---------------------------
SWEP.ViewModel      = "models/katharsmodels/handcuffs/handcuffs-1.mdl"
SWEP.WorldModel   = "models/katharsmodels/handcuffs/handcuffs-1.mdl"
-----------------------------------------------

-------------Primary Fire Attributes----------------------------------------
SWEP.Primary.Delay			= 0.9 	--In seconds
SWEP.Primary.Recoil			= 0		--Gun Kick
SWEP.Primary.Damage			= 0	--Damage per Bullet
SWEP.Primary.NumShots		= 1		--Number of shots per one fire
SWEP.Primary.Cone			= 0 	--Bullet Spread
SWEP.Primary.ClipSize		= -1	--Use "-1 if there are no clips"
SWEP.Primary.DefaultClip	= -1	--Number of shots in next clip
SWEP.Primary.Automatic   	= false	--Pistol fire (false) or SMG fire (true)
SWEP.Primary.Ammo         	= "none"	--Ammo Type
-------------End Primary Fire Attributes------------------------------------
 
-------------Secondary Fire Attributes-------------------------------------
SWEP.Secondary.Delay		= 0.9
SWEP.Secondary.Recoil		= 0
SWEP.Secondary.Damage		= 0
SWEP.Secondary.NumShots		= 1
SWEP.Secondary.Cone			= 0
SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic   	= false
SWEP.Secondary.Ammo         = "none"
-------------End Secondary Fire Attributes--------------------------------
 
function SWEP:Reload()
end 
 
 if ( CLIENT ) then
	function SWEP:GetViewModelPosition( pos, ang )
		ang:RotateAroundAxis( ang:Forward(), 90 ) 
		pos = pos + ang:Forward()*4
		return pos, ang
	end 
end
 
function SWEP:Think()
end

function SWEP:Initialize()
end

function SWEP:PrimaryAttack()
	local trace = { }
	trace.start = self.Owner:EyePos();
	trace.endpos = trace.start + self.Owner:GetAimVector() * 60;
	trace.filter = self.Owner;
		
	local tr = util.TraceLine( trace );
		
	if( tr.Entity:IsValid() and ( tr.Entity:IsPlayer() ) ) then
		if( tr.Entity:GetNWBool( "FrozenYay" ) == true ) then
			return; end
		tr.Entity:SetNWBool( "FrozenYay", true )
		tr.Entity:PrintMessage( HUD_PRINTCENTER, "You are now handcuffed." );
	end
end

function SWEP:SecondaryAttack()
	local trace = { }
	trace.start = self.Owner:EyePos();
	trace.endpos = trace.start + self.Owner:GetAimVector() * 60;
	trace.filter = self.Owner;
		
	local tr = util.TraceLine( trace );
		
	if ( tr.Entity:IsValid() and ( tr.Entity:IsPlayer() ) ) then
		if( tr.Entity:GetNWBool( "FrozenYay" ) == true ) then
			tr.Entity:SetNWBool( "FrozenYay", false )
		else
			self.Owner:PrintMessage( HUD_PRINTCENTER, "Target isn't handcuffed." );
		end
	end
end

